﻿--CLOCK_UPDATE_RATE = 0.1;
local print, buildbar 
--local rows, cols = 4, 8
XBar_Done = nil;
playerName = "default";
-- We need to wait for a couple of events during load up to do some things.
-- We can be sure out saved data is available at VARIABLES_LOADED, and
-- We can alter default blizz items after PLAYER_LOGIN


XBar_Options = { }; --holds all of the settings.
XBarTimes = {};
XBarTimes["Stoneskin Totem"] = 120;

local eventframe = CreateFrame("Frame")
eventframe:SetFrameStrata("LOW")
eventframe:RegisterEvent("VARIABLES_LOADED")
eventframe:RegisterEvent("PLAYER_LOGIN")
eventframe:SetScript("OnEvent", function(self, event, ...)
	-- for a variety of reasons I like waiting until PLAYER_LOGIN - there's info 
	-- available here that's not available at load time.
	if ( event == "PLAYER_LOGIN" ) then
		if (UnitName("player") ~= UNKNOWNBEING and UnitName("player") ~= UNKNOWNOBJECT and UnitName("player") and not playerName) then
			playername = UnitName("player").." of "..GetCVar("realmName");
		end;
		loadvariables();
		buildbar() populatebar()
	end
	if ( event == "VARIABLES_LOADED" ) then
		SLASH_XBar1 = "/XBar";
		SLASH_XBar2 = "/xb"; -- A shortcut or alias
		SLASH_XBarUNLOCK1 = "/xbunlock";
		SlashCmdList["XBar"] = XBar_Command;
		SlashCmdList["XBarUNLOCK"] = XBar_Unlock;
		TimeSinceLastUpdate = 0;
	end
	if ( event == "UNIT_SPELLCAST_SUCCEEDED" ) then
		if ( arg1 == "player" ) then
			EarthText:SetText(XBarTimes[arg2]);
		end
	end
end)
eventframe:SetScript("OnUpdate", function() XBar_OnUpdate(arg1) end)

function print(str)
	DEFAULT_CHAT_FRAME:AddMessage(tostring(str))
end

--Serts the starting variables if they dont already exist.
function loadvariables()
	if ( not XBar_Options ) then
		XBar_Options[playerName] = {
			["x"] = 250,
			["y"] = 200,
			["cols"] = 8,
			["rows"] = 4,
			["scale"] = 1,
			["horizontal"] = "true",
			["version"] = ver,
			["hidebar"] = "false",
			["order"] = "az",
		};
	end
	if (not XBar_Options[playerName]) then
			XBar_Options[playerName] = {
			["x"] = 250,
			["y"] = 200,
			["cols"] = 8,
			["rows"] = 4,
			["scale"] = 1,
			["horizontal"] = "true",
			["version"] = ver,
			["hidebar"] = "false",
			["order"] = "az",
		};
	end
end

--***Lets create the bar and config panel.
function buildbar()
  --if UnitClass("player") == "Shaman" then
	-- create a parent frame to anchor to - this can later be used as a state or anchor header
	local XBaranchor = CreateFrame("Frame", "XBarAnchorFrame", UIParent)
	-- an anchorframe must have a height and width to anchor to it.  Also, it must have these later
	-- if you use them for anchor up/down and anchor click frames
	XBaranchor:SetWidth(2) XBaranchor:SetHeight(2)
	XBaranchor:IsMovable("true");
	local rows = 4;
	local cols = 8;
	--XBaranchor.texture = "Interface\AddOns\XBar\Img\Handle"
	local height, width
	local action = 73;
	for row = 1, rows do
		for col = 1, cols do
			local btn = CreateFrame("CheckButton", "XBarButton"..action, XBaranchor, "ActionBarButtonTemplate")
			btn:SetScript("OnAttributeChanged", ActionButton_UpdateAction)
			btn:SetAttribute("type", "action")
			btn:SetAttribute("action", action)
			-- we're going to be placing the buttons relative to the anchor based on their width
			-- and later, if they are scaled we need to take that into account
			height = height or btn:GetHeight()
			width = width or btn:GetWidth()
			btn:SetPoint("TOPLEFT", -1 * (row-1)*height, (col-1)*width)
			action = action+1
		end
	end
	-- anchor the anchor based on its overall width and height
	--XBaranchor:SetPoint("CENTER", ((rows/2) * height)+450, -1 * (cols/2) * width)
	--XBaranchor:SetPoint("CENTER", "UIParent", "BOTTOM", 600, 450);
	XBaranchor:SetPoint("CENTER", "UIParent", "BOTTOM", XBar_Options[playerName]["x"], XBar_Options[playerName]["y"]);
	--local handleH = CreateFrame("Button", "XBarHandleH", XBaranchor, "ActionBarButtonTemplate")
	--handleH:SetPoint("TOPLEFT", 10, -10)
	--handleH.texture = "Interface\AddOns\XBar\Img\Handle"
	--handleH:SetAttribute("type", "button")
	--local handleV = CreateFrame("Button", "XBarHandleV", XBaranchor, "ActionBarButtonTemplate")
	--handleV:SetPoint("TOPLEFT", 10, -10)
	--handleV.texture = "Interface\AddOns\XBar\Img\Handle"
	--handleV:SetAttribute("type", "button")
	--EarthText = eventframe:CreateFontString(nil,"ARTWORK","GameFontNormal");
	--EarthText:SetText("text");
	--EarthText:SetPoint("CENTER", "XBaranchor", "CENTER", 10, -30);
	
	XBar_Scale();
	XBar_Order();
	XBar_Done = true;
	XBaranchor:Hide();
	local frame = getglobal("XBarAnchorFrame");
   	if (frame) then
		frame:Show();
	end;
  --end
end

--Called on update event
function XBar_OnUpdate(arg1)					--Called on the OnUpdate event, deals with the timers
	if ( UnitClass("player") == "Shaman" ) then
		if ( XBar_Done == true ) then
			XBar_Done = nil;
			XBar_Scale();
			XBar_Order();
			--XBar_Update();
			--XBaranchor:SetPoint("CENTER", "UIParent", "BOTTOM", XBar_Options[playerName]["x"], XBar_Options[playerName]["y"]);
			XBar_Done = true;
		end
	end
end



function XBar_Command(cmd)					--/slash commands
	command = string.lower(cmd);

	local i = 1;
	arg = { };
	local tmparg = nil;
	for tmparg in string.gmatch(command, "%w+") do
		arg[i] = tmparg;
		i = i + 1;
	end
		
	if (string.find(command, "config")) then
		if( XBarConfig:IsVisible() ) then
      			XBarConfig:Hide();
    		else
      			XBarConfig:Show();
    		end
	elseif (string.find(command, "help")) then
		DEFAULT_CHAT_FRAME:AddMessage("XBar alpha 1.0");
		DEFAULT_CHAT_FRAME:AddMessage("To configure type '/XBar config'");
		DEFAULT_CHAT_FRAME:AddMessage("/XBar x y - sets the coordinates of XBar");
		--DEFAULT_CHAT_FRAME:AddMessage("To move the bar: Hold down the control key and right click the XBar");
	elseif ( arg[1] and arg[2] ) then
		--XBaranchor:SetPoint("CENTER", "UIParent", "BOTTOM", arg[1], arg[2]);
		DEFAULT_CHAT_FRAME:AddMessage("Setting XBar coords to: " ..arg[1].." "..arg[2]);
		XBar_Options[playerName]["x"] = arg[1];
		XBar_Options[playerName]["y"] = arg[2];
		XBar_Order();
	else
		DEFAULT_CHAT_FRAME:AddMessage("Type '/XBar help' for help");
		if( XBarConfig:IsVisible() ) then
      		XBarConfig:Hide();
    	else
      		XBarConfig:Show();
    	end
	end
end


--Called too scale the shammy bars.
function XBar_Scale()
	--First we do the frame
   	local frame = getglobal("XBarAnchorFrame");
   	if (frame) then
		if(XBar_Options[playerName]["scale"]) then 
			frame:SetScale(XBar_Options[playerName]["scale"]);
		else
			frame:SetScale(1);
		end;
	end;

	local action = 73;
	local temp = 1;
	for temp = 1, 32 do
		button = getglobal("XBarButton"..action);
		if(XBar_Options[playerName]["scale"]) then 
			button:SetScale(XBar_Options[playerName]["scale"]);
		else
			button:SetScale(1);
		end;
		action = action+1;
	end
end

function XBar_Hide()
   local frame = getglobal("XBarAnchorFrame");
   if (frame) then
     if(  frame:IsVisible() ) then
       frame:Hide();
     else
       frame:Show();
     end
   end
end

function XBar_Order()
	if (XBar_Options[playerName]) then
		if (not XBar_Options[playerName]["horizontal"]) then
			XBar_Options[playerName]["horizontal"] = "false"
			XBar_Options[playerName]["order"] = "za"			
		end
		
		--XBaranchor:SetPoint("CENTER", "UIParent", "BOTTOM", XBar_Options[playerName]["x"], XBar_Options[playerName]["y"]);
		local frame = getglobal("XBarAnchorFrame");
   		if (frame) then
			frame:SetPoint("CENTER", "UIParent", "BOTTOM", XBar_Options[playerName]["x"], XBar_Options[playerName]["y"]);
		end;

		local rows = XBar_Options[playerName]["rows"];
		local cols = XBar_Options[playerName]["cols"];
		--Do the buttons order them.
		local action = 73;
		for row = 1, rows do
			for col = 1, cols do		
				local button = getglobal("XBarButton"..action);
				height = height or button:GetHeight();width = width or button:GetWidth()
				button:ClearAllPoints(); 
				if (XBar_Options[playerName]["horizontal"] == "false" and XBar_Options[playerName]["order"] == "az") then
					button:SetPoint("TOPLEFT",frame, -1 * (row-1)*height, (col-1)*width);
				elseif(XBar_Options[playerName]["horizontal"] == "false" and XBar_Options[playerName]["order"] == "za") then
					button:SetPoint("TOPLEFT",frame, 1 * (row-1)*height, (col-1)*width);
				elseif(XBar_Options[playerName]["horizontal"] == "true" and XBar_Options[playerName]["order"] == "az") then
					button:SetPoint("TOPLEFT",frame, -1 * (col-1)*height, (row-1)*width);
				elseif(XBar_Options[playerName]["horizontal"] == "true" and XBar_Options[playerName]["order"] == "za") then
					button:SetPoint("TOPLEFT",frame, 1 * (col-1)*height, (row-1)*width);
				end
				button:Show();
				action = action+1;
			end
		end
		--hide buttons that are not shown.. should be max of 2.
		local temp;
		for temp = action, 104 do
			local button = getglobal("XBarButton"..action);
			button:ClearAllPoints(); 
			button:Hide();
			action = action+1;
		end;
	end
end
				
--Not needed for a general movable action bar.
function populatebar()
  local notoccupied = true;
  for n = 1, 32 do
	if HasAction(n + 72) then
		notoccupied = nil;
	end
  end
	
  if ( UnitClass("player") == "Shaman" and notoccupied ) then
	local totems = {	"Grounding Totem",	   "Nature Resistance Totem",	"Windfury Totem",
				"Sentry Totem",		   "Windwall Totem",			"Grace of Air Totem",
				"Tranquil Air Totem",	   "Wrath of Air Totem",

				"Healing Stream Totem",	   "Poison Cleansing Totem",	"Mana Spring Totem",
				"Fire Resistance Totem",   "Disease Cleansing Totem",	"Mana Tide Totem",
				"nototem",			   "nototem",

				"Searing Totem",		   "Fire Nova Totem",		"Frost Resistance Totem",
				"Magma Totem",		   "Flametongue Totem",		"Totem of Wrath",
				"Fire Elemental Totem",	   "nototem",

				"Earthbind Totem",	   "Stoneskin Totem",		"Stoneclaw Totem",
				"Strength of Earth Totem", "Tremor Totem",		"Earth Elemental Totem",
				"nototem",			   "nototem" }

	local id = 73;
	for row = 1, rows*cols do
		putspell(totems[row],id);
		id = id+1;
	end
  --elseif (notoccupied) then
--	for row = 1, rows*cols do
--		putspell("Hearthstone",id);
--		id = id+1;
--	end
  end
end

function putspell(spell, id)
	if HasAction(id)
	then
	else 
		local spellid = getspellid(spell)
		if spellid then
			PickupSpell(spellid,SpellBookFrame.bookType);
			PlaceAction(id);
		end
	end
end

function getspellid(spell)
	local spellID = nil;
	for id = 1, 180, 1 do local spellName, subSpellName = GetSpellName(id, BOOKTYPE_SPELL);
		if spellName and string.find(spellName, spell, 1, true) 
		then 
			spellID = id;
		end
	end 
	return spellID
end


